<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="Credentials">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>Credentials </title>
        
        <link href="../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../index.html#23-credentials/understanding-credentials.html">Open topic with navigation</a>
        </p>
        <h1>Credentials </h1>
        <p style="font-weight: normal;">These days, more and more organizations are becoming vulnerable to outside threats due to weak password policies and insecure password management systems. Credentials provide a gateway into various accounts and systems, which can potentially provide access to additional targets on the network and lead to the extraction of confidential data from these targets. Therefore, as part of a penetration test, it is important to discover and present credential data that compels organizations to strengthen and enforce complex password policies to prevent vulnerabilities like password reuse and weak passwords. </p>
        <p style="font-weight: normal;">As part of your credentials audit, you want to identify weak passwords, the most commonly used passwords, and top base passwords. You will also want to reuse valid credentials, so that you can identify the impact of the stolen credentials across a network.This will help an organization understand their current posture, identify how they can strengthen password policies, and enforce passwords  requirements that meet industry best practices. </p>
        <p>To help you understand how credentials are obtained, stored, and managed by <span class="VariablesProductName">Metasploit Pro</span>, the following section will provide an overview of the key concepts and terms you must know before working with credentials. </p>
        <h2>Understanding Credential Terminology</h2>
        <p>Typically, when you think of a credential, you think of a username and password. In <span class="VariablesProductName">Metasploit Pro</span>, a username is referred to as a public, and the password is known as a private. Therefore, a credential can be a private, public, or a credential pair. So, to summarize the key credential terms:</p>
        <ul>
            <li value="1">A <b>public</b> is the username that is used to log in to a target. </li>
            <li value="2">A <b>private</b> is essentially the password that is used to authenticate to a target. It is usually a plaintext password, an SSH key, NTLM hash, or nonreplayable hash. Since the private can be an SSH key or hash, the term password is not broad enough to include these private types.  </li>
            <li value="3">A <b>credential pair</b> is a public and private combination that can be used to authenticate to a target. </li>
        </ul>
        <p>In addition to the key terms, here are some additional ones that you should familiarize yourself with:</p>
        <p class="subheading">Private Type</p>
        <p>A <b>private type</b> refers to whether the private is a plaintext password, an SSH key, NTLM hash, or nonreplayable hash.</p>
        <p class="subheading">Nonreplayable Hash</p>
        <p>A <b>nonreplayable hash</b> is a hash that cannot be replayed to authenticate to services. For example, any hash that was looted from <code>/etc/passwd</code> or <code>/etc/shadow</code> are nonreplayable hashes. </p>
        <p class="subheading">NTLM&#160;Hash</p>
        <p>An <b>NTLM hash</b> is a hash that can be replayed to authenticate to SMB. </p>
        <p class="subheading">Realm</p>
        <p>A <b>realm</b> refers to the functional grouping of database schemas to which the credential belongs. A realm type can be an Active Domain Directory, a  Postgres database, a DB2 database, or an Oracle&#160;System Identifier (SID). A public, private, or credential pair can have a realm, but it is not mandatory. </p>
        <p class="subheading">Incomplete Public</p>
        <p>An <b>incomplete public</b> refers a public that does not have a private. It can have a realm, but it is not required.</p>
        <p class="subheading">Incomplete Private</p>
        <p>An <b>incomplete private</b> refers to a private that does not have a public. It can have a realm, but it is not required. </p>
        <p class="subheading">Login</p>
        <p>A <b>login</b> is a credential that is associated with a particular service. Theoretically, a login can be used to authenticate to a service.&#160;For example, a credential pair, such as admin/admin, that can be used to authenticate to a service, like SSH, is a login. </p>
        <p class="subheading">Origin</p>
        <p>The <b>origin</b>  refers to how the credential was obtained or added to the project, such as through Bruteforce Guess, manual entry, or an imported credentials list. A origin can be manual, import, session, service, or cracked password.         <![CDATA[ ]]></p>
        <p class="subheading">Validated&#160;Credential</p>
        <p>A <b>validated credential</b> refers to a credential that has successfully authenticated to a target. </p>
        <p>To obtain credentials, you must loot them  from a compromised target. Looted credentials can be used to attempt additional logins to other services and hosts. </p>
        <p><span class="VariablesProductName">Metasploit Pro</span> stores all looted, imported, and manually added credentials in a project. </p>
        <h2>Obtaining Credentials</h2>
        <p>There are a few ways that you can obtain credentials. The main methods of acquiring credentials include exploiting a vulnerability and dumping the credentials from the compromised target; bruteforcing targets using weak and common default credentials; and searching publicly available resources for stolen credentials. The method you use depends on the level of access that you have to a target. </p>
        <p><span class="VariablesProductName">Metasploit Pro</span> enables you to leverage multiple attack methods to acquire credentials, such as exploiting unpatched vulnerabilities. For example, if you are able to discover a Windows system that is vulnerable to MS08-067, you may be able to exploit that target and log in to the system to gather information from it. With access to the system, you can extract data such as password hashes, plaintext passwords, and domain tokens. </p>
        <p>Many information systems are configured to use passwords as the first, and sometimes only, line of defense. And oftentimes, the passwords that are used are easy to guess passwords, or even blank passwords. This means that if you have the username, you can try to guess the password to log in to the target. For example, a Windows domain account that uses a weak or blank password can be easily guessed via bruteforce. </p>
        <p>Additionally, many systems are configured with the default account settings. These accounts usually share the same password across multiple instances, which means that if you know the default account settings for one account, you will be able to leverage those credentials to compromise  other targets across the network as well.&#160;In this case, you can manually add common default credentials and use the Quick Validation feature to validate the account credentials. If any credentials successfully authenticate to a target, you can run Credential Reuse to find additional targets on which the credentials are valid. </p>
        <p>So, to summarize the methods that you can use to obtain credentials with Metasploit:</p>
        <ul>
            <li value="1">You can find vulnerabilities and exploit them to obtain access to the target. Once you have access to a target, you can dump credentials and other confidential data from the exploited target. </li>
            <li value="2">You can run Bruteforce to guess commonly used, weak, and default credentials on services like AFP, DB2, FTP, HTTP, HTTPS, MSSQL, MySQL, POP3, PostgreSQL, SMB, SNMP, SSH, telnet, VNC, and WinRM.</li>
            <li value="3">You can manually add or import credentials to a project and run Quick Validation or Credential Reuse to find targets that can be authenticated. This method is useful when you have a set of commonly used credentials or known credentials you want to try on a set of targets. </li>
        </ul>
        <h3>Credential Origins</h3>
        <p>Every credential that is added to a project has an origin, which refers to the source of the credential. A credential will always have one of the following origins:</p>
        <ul>
            <li value="1">A <b>manual</b> origin indicates that you manually added the credential to the project using the Add button on the Manage Credentials page. </li>
            <li value="2">An <b>import</b> origin indicates that you imported the credential by uploading a CSV&#160;file or PWDump to the project.</li>
            <li value="3">A <b>service</b> origin indicates that the credential was obtained with Bruteforce. </li>
            <li value="4">A <b>session</b> origin indicates that the credential was collected from a session on an exploited target. </li>
            <li value="5">A <b>cracked password</b> origin indicates that <span class="VariablesProductName">Metasploit Pro</span> was able to crack the hash during evidence collection and decipher the plaintext password. </li>
        </ul>
    </body>
</html>